//
//  AppDelegate.m
//  menuparser
//
//  Created by 赵正罡 on 6/12/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "AppDelegate.h"
#import "XMLReader.h"

@implementation AppDelegate

@synthesize window = _window;
@synthesize textViewXML = _textViewXML;
@synthesize textViewFile = _textViewFile;
@synthesize textViewName = _textViewName;
@synthesize textFieldError = _textFieldError;

- (void)dealloc
{
    [super dealloc];
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Insert code here to initialize your application
}

-(NSArray *)xmlFilesAtPath:(NSURL *)path{
    NSError *error = nil;
    return [[NSFileManager defaultManager] contentsOfDirectoryAtURL:path includingPropertiesForKeys:nil options:NSDirectoryEnumerationSkipsHiddenFiles error:&error];
}

-(void)parserWithData:(NSData *)data andFileName:(NSString *)file atIndex:(NSInteger)index{
    NSError *error = nil;
    NSDictionary *root = [XMLReader dictionaryForXMLData:data error:&error];
    
    if(error){
        NSLog(@"%@, %@", file, error.description);
        [self.textFieldError setStringValue:[self.textFieldError.stringValue stringByAppendingFormat:@"\n%@", file]];
        return;
    }
    NSString *name = [XMLReader elementForPath:@"recipe/name" withRootNode:root];
    [self.textViewXML insertText:[NSString stringWithFormat:@"<item>\n"
                                                             "<index>%d</index>\n"
                                                             "<name>%@</name>\n"
                                                             "<file>%@</file>\n"
                                                             "<area>100</area>\n"
                                                             "</item>\n", index, name, file]];
    [self.textViewFile insertText:[NSString stringWithFormat:@"@\"%@\",\n", [file stringByReplacingOccurrencesOfString:@".xml" withString:@""]]];
    [self.textViewName insertText:[NSString stringWithFormat:@"@\"%@\",\n", name]];
//    <item>
//    <index>1</index>
//    <name>그릴에 구운 두부 카프레제</name>
//    <file>recipe002.xml</file>
//    <area>100</area>
//    </item>
}

-(void)parserXMLatPath:(NSURL *)path{
    NSArray *files = [self xmlFilesAtPath:path];
    //NSLog(@"%@", files);
    [self.textViewXML insertText:@"<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n"
                                  "<recipe>\n"
                                  "<result>\n"
                                  "<resultCode>0</resultCode>\n"
                                  "<resultMessage/>\n"
                                  "</result>\n"
                                  "<lists>\n"];
    NSInteger index = 0;
    for (NSURL *file in files) {
        [self parserWithData:[[NSFileManager defaultManager] contentsAtPath:[file path]] andFileName:[[file path] lastPathComponent] atIndex:index++];
    }
    [self.textViewXML insertText:@"</lists>\n"
                                  "</recipe>\n"];
}

-(void)chooseFile{
    // Create the File Open Dialog class.
    NSOpenPanel* openDlg = [NSOpenPanel openPanel];
    
    [openDlg setCanChooseFiles:NO];
    [openDlg setCanChooseDirectories:YES];
    [openDlg setAllowsMultipleSelection:NO];
    
    // Display the dialog.  If the OK button was pressed,
    // process the files.
    if ( [openDlg runModal] == NSOKButton )
    {
        // Get an array containing the full filenames of all
        // files and directories selected.
        NSArray* files = [openDlg URLs];
        //NSLog(@"%@", files);
        [self.textFieldError setStringValue:@"errors:"];
        [self.textViewXML setString:@""];
        [self.textViewFile setString:@""];
        [self.textViewName setString:@""];
        [self parserXMLatPath:files.lastObject];
    }
}

- (IBAction)buttonClicked:(NSButton *)sender {
    switch (sender.tag) {
        case 100:
            [self chooseFile];
            break;
            
        default:
            break;
    }
}

@end
